#include "express.hpp"
#include <iostream.h>
#include <conio.h>

int main( void)
{
   Expression::SetVerbose( FALSE);
   Expression::EnableMessageBox();

   ExpVariable f1( "FIELD_1");
   cout << f1 << " = " << int( f1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << !f1 <<  " = " << int( !f1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << f1.IsBlank() << " = " << int( f1.IsBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << f1.IsNotBlank() << " = " << int( f1.IsNotBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   ExpConstant c1( 10);
   cout << c1 << endl;

   cout << (ExpVariable( "FIELD_2") > ExpVariable( "FIELD_3")) << endl;

   cout << (f1 > c1 &&
      f1 >= c1 ||
      f1 < c1 &&
      f1 <= c1 ||
      f1 == c1 &&
      f1 != c1 ||
      (f1 *= c1)) << endl;

   cout << ((f1 + ((c1 - ExpConstant( 9)) * ExpConstant( 8))) / ExpConstant( 7)) << endl;

   ExpConstant c2( 1.23);

   getch();
   cout << (c2 == c1)      << " = " << double( c2 == c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 != c1)      << " = " << double( c2 != c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 < c1)       << " = " << double( c2 < c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 > c1)       << " = " << double( c2 > c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 <= c1)      << " = " << double( c2 <= c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 >= c1)      << " = " << double( c2 >= c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << c2              << " = " << double( c2);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << "int( " << c2 << ") = "  << int( c2);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << !c2             << " = " << double( !c2);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << c2.IsBlank()    << " = " << double( c2.IsBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << c2.IsNotBlank() << " = " << double( c2.IsNotBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 + c1)       << " = " << double( c2 + c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 - c1)       << " = " << double( c2 - c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 * c1)       << " = " << double( c2 * c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 / c1)       << " = " << double( c2 / c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c2 / c1)       << " = " << double( c2 / c1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   ExpConstant c3( "JOHN");
   ExpConstant c4( "John");
   ExpConstant c5( "J");
   ExpConstant c6( 'J');

   getch();
   cout << (c3 == c4)      << " = " << BOOL( c3 == c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 *= c4)      << " = " << BOOL( c3 *= c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 != c4)      << " = " << BOOL( c3 != c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 < c4)       << " = " << BOOL( c3 < c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 > c4)       << " = " << BOOL( c3 > c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 <= c4)      << " = " << BOOL( c3 <= c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 >= c4)      << " = " << BOOL( c3 >= c4);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3.IsBlank())  << " = " << BOOL( c3.IsBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3.IsNotBlank())  << " = " << BOOL( c3.IsNotBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   cout << (c3 == c5)      << " = " << BOOL( c3 == c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 *= c5)      << " = " << BOOL( c3 *= c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 != c5)      << " = " << BOOL( c3 != c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 < c5)       << " = " << BOOL( c3 < c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 > c5)       << " = " << BOOL( c3 > c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 <= c5)      << " = " << BOOL( c3 <= c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 >= c5)      << " = " << BOOL( c3 >= c5);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c5.IsBlank())  << " = " << BOOL( c5.IsBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c5.IsNotBlank())  << " = " << BOOL( c5.IsNotBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   cout << (c3 == c6)      << " = " << BOOL( c3 == c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 *= c6)      << " = " << BOOL( c3 *= c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 != c6)      << " = " << BOOL( c3 != c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 < c6)       << " = " << BOOL( c3 < c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 > c6)       << " = " << BOOL( c3 > c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 <= c6)      << " = " << BOOL( c3 <= c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c3 >= c6)      << " = " << BOOL( c3 >= c6);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c6.IsBlank())  << " = " << BOOL( c6.IsBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (c6.IsNotBlank())  << " = " << BOOL( c6.IsNotBlank());
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   ExpConstant cTrue( 1);
   ExpConstant cFalse( 0);

   getch();
   cout << cTrue << " = " << BOOL( cTrue);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << cFalse << " = " << BOOL( cFalse);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cTrue && cFalse) << " = " << BOOL( cTrue && cFalse);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cTrue || cFalse) << " = " << BOOL( cTrue || cFalse);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cFalse && cTrue) << " = " << BOOL( cFalse && cTrue);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cFalse || cTrue) << " = " << BOOL( cFalse || cTrue);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cTrue && (cTrue || cFalse)) << " = " << BOOL( cTrue && (cTrue || cFalse));
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cTrue || (cTrue && cFalse)) << " = " << BOOL( cTrue || (cTrue && cFalse));
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cFalse && (cTrue || cFalse)) << " = " << BOOL( cFalse && (cTrue || cFalse));
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << (cFalse || (cTrue && cFalse)) << " = " << BOOL( cFalse || (cTrue && cFalse));
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   getch();

   Expression ed1( ExpConstant( TDate( 9, 6, 1995)) + ExpConstant( 10));
   cout << ed1 << " = " << (TDate) ed1;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << ed1 << " = " << (TTime) ed1;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   Expression ed2 = ExpConstant( TDate( 29, 6, 1995)) - ExpConstant( TDate( 28, 4, 1995));
   cout << ed2 << " = " << (TDate) ed2;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << ed2 << " = " << (int) ed2;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   ExpConstant et0 = TTime();
   Expression et1( ed1 > et0);
   cout << et1 << " = " << BOOL( et1);
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   Expression et2( ExpConstant( TTime()) - ExpConstant( 60));
   cout << et2 << " = " << (TTime) et2;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << et2 << " = " << (TDate) et2;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   Expression et3 = ExpConstant( TTime()) - ExpConstant( TDate());
   cout << et3 << " = " << (TTime) et3;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;
   cout << et3 << " = " << (INT32) et3;
   cout << "[" << ExpElement::GetEvalError() << "]" << endl;

   pCANExpr p = ed1;

   return 0;
}
